// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "LMSpawnPosition.generated.h"

class UCameraComponent;

UCLASS()
class LEGUMEMIX_API ALMSpawnPosition : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	ALMSpawnPosition();

	// Méthode pour vérifier si le spawn est possible
	virtual bool CanSpawn();
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta = (AllowPrivateAccess = "true"), Category = "Legumix")
	float TimerCooldown = 1.5;
	void StarCooldown();
	
protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;
	
	virtual void EndCooldown();

	UPROPERTY()
	UCameraComponent* PlayerCamera = nullptr;
	
public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

private:
	bool IsPlayerVisible() const;
	FTimerHandle ProcessCooldown;
	bool IsOnCooldow;
};
